<?php

namespace Drupal\limit_domain_access_by_role\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class LimitDomainAccessByRoleConfigForm.
 */
class LimitDomainAccessByRoleConfigForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'limit_domain_access_by_role.settings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'limit_domain_access_by_role_config_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('limit_domain_access_by_role.settings');
    $form['technical_domains'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Technical domains (to allow admin operations on)'),
      '#description' => $this->t('Provide the domain hosts to be used as technical domain to allow (admin) roles to access. One domain per line. Wildcards are supported, like *.example.com.'),
      '#default_value' => $config->get('technical_domains'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);

    $this->config('limit_domain_access_by_role.settings')
      ->set('technical_domains', $form_state->getValue('technical_domains'))
      ->save();
  }

}
